*    "  "

#DEFINE         CHR(9)
#DEFINE          CHR(13)
#DEFINE          CHR(10)
#DEFINE          CHR(12)
#DEFINE        CHR(13)+CHR(10)
#DEFINE   CHR(38)


**************************************************************************************
*    (       ( "")
* :
*  ()        -     (  )
*  (1N)      -   
*  (1N, "W") -        
*  (1N, "A") -         
**************************************************************************************
FUNCTION 
PARAMETERS m.parI, m.parAW
PRIVATE ALL LIKE ?
m.p = PCOUNT()

m.s = " , /, "
m.k = GETWORDCOUNT(m.s,",")
m.r = .NULL.  &&  
DO CASE
   CASE m.p=0  &&     
        m.r = m.k
   CASE m.p=1 .AND. BETWEEN(m.parI,1,m.k)  &&    
        m.r = ALLTRIM(GETWORDNUM(m.s, m.parI, ","))
   CASE m.p=2 .AND. BETWEEN(m.parI,1,m.k) .AND. m.parAW="W"  &&     
        m.r = INLIST(m.parI,2,3)
   CASE m.p=2 .AND. BETWEEN(m.parI,1,m.k) .AND. m.parAW="A"  &&     
        m.r = INLIST(m.parI,3)
   OTHERWISE
        ERROR "  "+VALTOTIP(m.parI, "C")
ENDCASE
RETURN m.r
   



**************************************************************************************
*    (1)      (, "  " -> " ..")
**************************************************************************************
FUNCTION 
LPARAMETERS par
LOCAL a,b,c,d
m.a = GETWORDNUM(m.par,1)
m.b = GETWORDNUM(m.par,2)
m.c = GETWORDNUM(m.par,3)
m.d = GETWORDNUM(m.par,4)
RETURN ALLTRIM(IIF(EMPTY(m.a), "", m.a+" ")+;
               IIF(EMPTY(m.b), "", LEFT(m.b,1)+".")+;
               IIF(EMPTY(m.c), "", LEFT(m.c,1)+".")+;
               IIF(EMPTY(m.d), "", LEFT(m.d,1)+"."))






**************************************************************************************
*     (SET)    DataSession=2 (    )
* .      FormWizStd (  - FormWizStd    (  Load))
**************************************************************************************
PROCEDURE Load_

SET TALK OFF       &&     
SET DELETED ON     &&      
SET DATE GERMAN    &&     ..
SET SAFETY OFF     &&       (,   )
SET CENTURY ON     &&   
SET HOURS TO 24    &&    - 24-


SET CONFIRM ON     &&  Enter   
SET ESCAPE OFF     &&   Esc    

SET COLLATE TO "RUSSIAN"  &&   ,   - , (  )

RETURN




**************************************************************************************
*   ()  ()   (1O)
*          Tag,    ,   DataEnvironment (DE) 
*       NOT ReadOnly,      
**************************************************************************************
FUNCTION Get_
PARAMETERS m.parThisForm
PRIVATE ALL LIKE ?

m.r = m.parThisForm.Tag  &&  Tag    ,    
IF EMPTY(m.r)
   m.r = ""
   FOR EACH m.o IN m.parThisForm.DataEnvironment.Objects  &&    
       *   ,    ( ReadOnly)    
       IF m.o.BaseClass="Cursor" .AND. !m.o.ReadOnly
          m.r = m.o.Alias
          EXIT
       ENDIF
   ENDFOR
   IF EMPTY(m.r)
      RETURN ""
   ENDIF
ENDIF
RETURN m.r




**************************************************************************************
*        (   ) 
*  :   ,  ,         ,
*      - ,  ,   .
*      -    ( ,    ),     :
*  >0.n - 
*  >0   - 
*  <0   - 
*  -          , ...
*   -    (1)   [2]    
*   (1)   ,    SCATTER-  ,  
**************************************************************************************
FUNCTION Get__
PARAMETERS m.parUN, m.par
PRIVATE ALL LIKE ?

IF VARTYPE(m.parUN)="O"  &&  (1)    SCATTER-

   m.k = "_dkjhskjahdsvs"  &&  -  ,   
   IF PCOUNT()<2 .OR. EMPTY(m.par)  &&  SCATTER-- (1)
      m.r = CREATEOBJECT("Empty")
      =ADDPROPERTY(m.r, "",      oCOPY(m.parUN, ";"+m.k))  && SCATTER- 
      =ADDPROPERTY(m.r, "", m.parUN.&k)  && 
   ELSE  &&  SCATTER- (1)   (2)   SCATTER--
      m.r = oCOPY(m.parUN)
      *    "O_" -      SCATTER-
      =ADDPROPERTY(m.r, m.k, IIF(m.par="O.", "", "O.") + m.par)
   ENDIF

ELSE  &&  (1)    

   m.u = INT(ABS(m.parUN))             &&   
   m.z = SIGN(m.parUN)                 &&  
   m.d = INT(10 * (ABS(m.parUN) % 1))  &&   , 1  

   IF PCOUNT()<2 .OR. EMPTY(m.par)  &&  - (1)
      m.r = CREATEOBJECT("Empty")
      =ADDPROPERTY(m.r, "",      m.u)  &&  
      =ADDPROPERTY(m.r, "", ICASE(m.z=-1, "",;  && 
                                         m.z=0,  "",;
                                         m.d=0,  "",;
                                                 ""))
   ELSE  &&   (1)   (2)   -
      m.r = ICASE(m.par="",       -m.u,;
                  m.par="",      0,;
                  m.par="", m.u,;
                                                m.u+0.1)  && 
   ENDIF
ENDIF

RETURN m.r




**************************************************************************************
*    Init   ( ,   ,  ""    ):
*   -        
*   -   / 
*   - FormWizStd    (  Init)
* (1O) -     
* [2] -        (, "A", "A,W")    
**************************************************************************************
FUNCTION Init_
PARAMETERS m.parThisForm, m.par___
PRIVATE ALL LIKE ?
PRIVATE m.xSelect
m.p = PCOUNT()

m.xSelect = SELECT()

WITH m.parThisForm  &&       
   
   * ,      ,       
   m.o = oEXIST(.Name)  &&        ()
   IF !ISNULL(m.o)  && ,  
      IF m.o.ButtonSET1.cmdEXIT.Visible .AND.;  &&    ,     
         m.o.ButtonSET1.cmdEXIT.Enabled
         m.o.ButtonSET1.cmdEXIT.Click  &&       ,     
      ELSE  &&      ...
         m.o.Show      &&  
         SELECT (m.xSelect)
         RETURN .F. && Init    ,     
      ENDIF
   ENDIF

   *   () ,      
   m.a = ""
   IF PEMSTATUS(m.parThisForm, "Load_Alias", 5)  &&  ,      ()
      m.a = .Load_Alias
   ENDIF
   IF EMPTY(m.a)
      ERROR "      "+m.parThisForm.Caption
      SELECT (m.xSelect)
      RETURN .F.  &&    ,   
   ENDIF
   
   *   ,      (    ,    ...)
   m.b = CURSORGETPROP("Database", m.a)  &&   ( ),    
   SET DATABASE TO (m.b)  &&   ,    

   m.k = .NULL.  && -,    ,   -      ( , 0/ 0,  )
   IF PEMSTATUS(m.parThisForm, "Init_", 5)
      m.k = Get__(m.parThisForm.Init_)  &&  ,    , 
      =ADDPROPERTY(m.k, "", m.a)
      =ADDPROPERTY(m.k, "",  m.b)
   ENDIF
   
   *         ( (2))
   *          
   * (, (2)="A"   ""...)
   m.e = .T.  &&  "       "
   IF m.p>=2 .AND. !EMPTY(m.par___)  &&         [ -  ]
      m.e = .F.
      FOR m.i=1 TO GETWORDCOUNT(m.par___,",")
          m.l = ALLTRIM(GETWORDNUM(m.par___, m.i, ","))
          IF (m.Cashier_, m.l)  &&       
             m.e = .T.
             EXIT
          ENDIF
      ENDFOR
   ENDIF
   IF !m.e  &&           , :
      WAIT "   !" WINDOW NOWAIT
      DO BEEPER WITH 3
      SELECT (m.xSelect)
      RETURN .F.  && Init    ,     
   ENDIF

   *   ,     ,     ""    
   IF !ISNULL(m.k) .AND. !m.k.="O." .AND. !EMPTY(m.k.)  &&   ,     
      SELECT (m.k.)
      m.f = FIELD(1)  &&  1   -       
      LOCATE FOR &f=ABS(INT(m.k.))
      IF !FOUND()
         SELECT (m.xSelect)
         RETURN .F.  && Init    ,     
      ENDIF
      SELECT (m.xSelect)
   ENDIF
   *  .Init_         .Show  (. Show_)
   
   *   ,   ,    (,      . )
   .AddProperty("Caption_old",  .Caption)

   *   _/_ -     ,  
   IF !ISNULL(m.k)
      m.a = m.k.  && ,      ()
      .Caption = From(m.a, "Caption")  &&   -
   
      IF PEMSTATUS(m.parThisForm, "_", 5)  &&  / /, ,  
         IF m.k.="O."
            IF PEMSTATUS(m.k., "_", 5)  &&       _,_,   
               ._.Value = m.k.._
               ._.Value = m.k.._
               ._.Visible = .T.
               ._.Visible = .T.
            ENDIF
         ELSE
            IF !TYPE(m.a+"._")="U"  &&       _,_,   
               ._.ControlSource = m.a+"._"
               ._.ControlSource = m.a+"._"
               ._.Visible = .T.
               ._.Visible = .T.
               ._.Refresh
               ._.Refresh
            ENDIF
         ENDIF
      ENDIF
   ENDIF

   *    ,   ,    ,       
   =oEXIST(.Name, m.parThisForm)

ENDWITH

SELECT (m.xSelect)
RETURN .T.





**************************************************************************************
*       (1O),    Show  :
*  -        
*  -    ,   ,  .   .Init_ 
*   - FormWizStd    (  Show)
*  .F.     (,   )
**************************************************************************************
FUNCTION Show_
PARAMETERS m.parThisForm
PRIVATE ALL LIKE ?

*     m.r,  :
#DEFINE r             0
#DEFINE r 1
#DEFINE r_       2
#DEFINE rO_Top_EMPTY          3
#DEFINE rO_Top_               4
#DEFINE r         5
#DEFINE r                6

WITH m.parThisForm

m.k = .NULL.  &&   ,   Init ,     
IF PEMSTATUS(m.parThisForm, "Init_", 5)
   m.k = Get__(.Init_)  &&  ,    , 
ENDIF
m.s = ""   &&      (.   . FormWizStd),    ,    
m.z = ""   &&  ,    (, " ",  " "...)
m.r = 0    &&   ,  ..   -    (.  #DEFINE)
IF ISNULL(m.k)  &&    ,   , ,   ...
   m.r = BITSET(m.r, r)
ELSE
   DO CASE
      CASE m.k.=""  &&  "  "
           .Caption = .Caption_old+" ( )"
           DO BEEPER WITH 0.9
           m.s = "CmdADD, CmdEDIT, CmdEXIT"
           m.z = "cmdADD"  && !     ,      DE     "Add Record"
           KEYBOARD "A"  &&       "Add"
           m.r = BITSET(m.r, r_)
           m.r = BITSET(m.r, rO_Top_EMPTY)
      CASE m.k.=""  &&  "  "
           m.s = "CmdEXIT"
           m.r = BITSET(m.r, r)
      CASE m.k.="O."  &&  "  SCATTER-"
           m.s = "CmdEXIT"
           m.r = BITSET(m.r, r)
           m.r = BITSET(m.r, r)
      CASE m.k.="O."  &&  " SCATTER-"
           .Caption = .Caption_old + " ()"
           DO BEEPER WITH 0.5
           m.s = "CmdADD, CmdEXIT"
           m.r = BITSET(m.r, r)
           m.r = BITSET(m.r, rO_Top_)
      CASE m.k.="O."  &&  " SCATTER-"
           .Caption = .Caption_old + " ( )"
           DO BEEPER WITH 0.5
           m.s = "CmdADD, CmdEXIT"
           m.r = BITSET(m.r, r)
           m.r = BITSET(m.r, r)
           m.r = BITSET(m.r, r_)
           m.r = BITSET(m.r, rO_Top_EMPTY)
      CASE m.k.=""  &&  " "
           .Caption = .Caption_old+" ()"
           DO BEEPER WITH 0.5
           m.s = "CmdADD, CmdEDIT, CmdEXIT"
           m.z = "cmdEDIT"
           m.r = BITSET(m.r, rO_Top_)
      CASE m.k.=""  &&  " "
           .Caption = .Caption_old+" ()"
           DO BEEPER WITH 0.1
           m.s = "CmdDELETE, CmdEXIT"
           m.z = "cmdDELETE"
           m.r = BITSET(m.r, r)
           m.r = BITSET(m.r, r)
      OTHERWISE
           ERROR "  "+m.k.
           m.r = BITSET(m.r, r)
   ENDCASE
ENDIF
ENDWITH

*     
IF !EMPTY(m.z)  &&      WITH, ..     ,       
   m.parThisForm.ButtonSET1.&z..Click  && ,    , .    FormWizStd...
ENDIF

*    , ,    ,      
IF VARTYPE(m.parThisForm)="O"  &&     , ..  ,   
   
   IF !BITTEST(m.r, r)  &&      

      IF BITTEST(m.r, r)  &&     SCATTER- ReadWrite
         =(m.parThisForm, "O_To_Value_ControlSource", m.k.)
      ENDIF

      IF BITTEST(m.r, r)  &&    
         =(m.parThisForm, "Enabled_EQ_F")  &&    .Enabled:=.F. (  "")
      ENDIF

      IF BITTEST(m.r, r_)  &&      m.Cashier_ (,   )
         =(m.parThisForm, "Value_")
      ENDIF

      IF BITTEST(m.r, r)  &&   
         *        ( "", -...)
         =(m.parThisForm, "Value_Clear")  &&   

         *     -  .   ,  -
         WITH m.parThisForm
              =(m.parThisForm, "._Init")  &&   - (   )
         ENDWITH
      ENDIF

      *    , ..    ,     
      FOR EACH m.o IN m.parThisForm.ButtonSET1.Controls
          m.v = LIKEin(m.s, m.o.Name)  && .T.   -      , .F. -   .. 
          IF !m.v=m.o.Visible
             m.o.Visible = m.v  && /  ( .   m.s)
          ENDIF
      ENDFOR
   ENDIF

   *         
   * ,        ,     , ...
   IF PEMSTATUS(m.parThisForm, "Show_This", 5)
      IF !m.parThisForm.Show_This()
         m.r = BITSET(m.r, r)
      ENDIF
   ENDIF

   IF !BITTEST(m.r, r)  &&      
      IF BITTEST(m.r, rO_Top_) .OR.;  &&     
         BITTEST(m.r, rO_Top_EMPTY)   &&      ,   
         m.v = IIF(BITTEST(m.r, rO_Top_), "O_Top_", "O_Top_EMPTY")
         m.o = (m.parThisForm, m.v, .NULL.)  &&    
         IF !ISNULL(m.o)  &&   ,    ,    ,       
            m.parThisForm.AddProperty("", m.o.Name)
         ENDIF
      ENDIF
   ENDIF
ENDIF

RETURN !BITTEST(m.r, r)  &&  .F.     (,   )




**************************************************************************
*       (1O)     (2)
* (..  /   /      , ,    Enabled:=.F.  )
*   [3],      [3] (  - ),      (2)
*     T  F
* (,   [3X,O] -    ,       [3])
*   - FormWizStd (.  ,  : ButtonSET1, _, _)
**************************************************************************
PROCEDURE 
PARAMETERS m.parThisForm, m.parPROG, m.parDOP
PRIVATE ALL LIKE ?
m.r = IIF(PCOUNT()<3, .T., m.parDOP)
FOR EACH m.o IN m.parThisForm.Objects  &&    
    IF m.o.BaseClass+" "="Grid"+" " .OR.;      && GRID -  ,  ...       (. . ControlSource...)
       !PEMSTATUS(m.o, "Value", 5) .OR.;       && ,    Value (..  )
       INLIST(m.o, m.parThisForm.ButtonSET1,;  &&    
                   m.parThisForm._,;    &&   _,_
                   m.parThisForm._)
       LOOP
    ENDIF
    IF PCOUNT()<3
       m.v = &parPROG(m.o)  &&   
    ELSE
       m.v = &parPROG(m.o, m.r)  &&   ,   
    ENDIF
    IF VARTYPE(m.v)="L"  && /   /
       IF EMPTY(m.v)  && /  .F.,    , (   ,     [3])
          IF PCOUNT()<3  &&    ,   .F.
             m.r = .F.
          ENDIF
          EXIT
       ENDIF
    ELSE  && /  ,        / (2),  
       m.r = m.v
    ENDIF
ENDFOR
RETURN m.r




*     (2)  ()
*   /    ,     ..
*************************************************************************
PROCEDURE Enabled_EQ_F  &&     
PARAMETERS m.parO
IF m.parO.Enabled
   IF m.parO.BaseClass+" "="Grid"+" "
      IF !m.parO.ReadOnly
         m.parO.ReadOnly = .T.  &&    GRID
      ENDIF
   ELSE
      IF m.parO.Enabled
         m.parO.Enabled = .F.  &&   
      ENDIF
   ENDIF
   IF PEMSTATUS(m.parO, "DisabledForeColor", 5) .AND.;
      PEMSTATUS(m.parO, "ForeColor", 5) .AND.;
      !m.parO.DisabledForeColor=m.parO.ForeColor
      m.parO.DisabledForeColor = m.parO.ForeColor  && ,     ForeColor 
   ENDIF
ENDIF
RETURN .T.


PROCEDURE Value_  &&    ,      
PARAMETERS m.parO
IF m.parO.Class+" "=""+" " .AND.;
   m.parO.Visible
   m.parO.Value = m.Cashier_
   IF !(m.Cashier_, "A")  &&       ""   ( ...)
      m.parO.Enabled = .F.
   ENDIF
   RETURN .F.
ENDIF
RETURN .T.


PROCEDURE T___  && ()  T,     (  Comment=="*") - 
PARAMETERS m.parO
RETURN (ALLTRIM(m.parO.Comment)=="*" .OR. !T___(m.parO))  &&   .Comment="*"    (  % )


PROCEDURE T___  && ()  T,     - 
PARAMETERS m.parO
RETURN (ISNULL(m.parO.Value) .OR. EMPTY(m.parO.Value))


PROCEDURE O_Top_  && ()     ,    
PARAMETERS m.parO, m.parDOP
IF ISNULL(m.parDOP)
   RETURN m.parO
ENDIF
IF m.parO.Top<m.parDOP.Top
   RETURN m.parO
ENDIF
RETURN m.parDOP


PROCEDURE O_Top_EMPTY  && ()     ,    ,  
PARAMETERS m.parO, m.parDOP
IF ISNULL(m.parO.Value) .OR. EMPTY(m.parO.Value)
   IF ISNULL(m.parDOP)
      RETURN m.parO
   ENDIF
   IF m.parO.Top<m.parDOP.Top
      RETURN m.parO
   ENDIF
ENDIF
RETURN m.parDOP


PROCEDURE Value_Clear  &&   Value
PARAMETERS m.parO
IF !ISNULL(m.parO.Value) .AND. !EMPTY(m.parO.Value)  &&   - 
   m.parO.Value = EMPTYVAL(m.parO.Value)  &&     ,   ,   
ENDIF
RETURN .T.


PROCEDURE O_To_Value_ControlSource  &&  :   (2),  Value    ,  ControlSource!
PARAMETERS m.parO, m.parDOP
PRIVATE ALL LIKE ?
m.c = m.parO.ControlSource  && -   , ( ".")
IF !EMPTY(m.c)
   m.t = ALLTRIM(GETWORDNUM(m.c, GETWORDCOUNT(m.c,"."), "."))  &&     ( "")
   m.parO.Tag = m.t  &&     Tag,  ,       
   m.parO.ControlSource = ""  &&       - 
   IF PEMSTATUS(m.parDOP, m.t, 5)  &&   -   ,      Value
      m.parO.Value = m.parDOP.&t
      IF !m.parO.Enabled
         m.parO.Enabled = .T.  &&    
      ENDIF
      IF m.parO.ReadOnly
         m.parO.ReadOnly = .F.
      ENDIF
   ELSE
      m.parO.Visible = .F.  &&      
   ENDIF
ENDIF
RETURN m.parDOP


PROCEDURE O_From_Value  &&  :  Value    ,   (2)
PARAMETERS m.parO, m.parDOP
PRIVATE ALL LIKE ?
m.t = m.parO.Tag  &&  ,     , ( "")
m.r = m.parDOP    && ,       
IF !EMPTY(m.t)
   m.r = IIF(!ISNULL(m.r), m.r, CREATEOBJECT("Empty"))
   =ADDPROPERTY(m.r, m.t, m.parO.Value)
ENDIF
RETURN m.r




**************************************************************************
*       (1),     (2)
* !  () ..       
*   [3] -      (    )
*  -  ,      [3]
**************************************************************************
FUNCTION StringFromTable
PARAMETERS m.parI, m.parUN, m.parFIELD
PRIVATE ALL LIKE ?
m.p = PCOUNT()
m.i = From(m.parI)        &&  (        - / From())
m.a = From(m.i, "Alias")  &&    
IF m.p<3 .OR. EMPTY(m.parFIELD)   &&        
   m.e = From(m.i, "StringEval")  &&       
ELSE
   m.e = m.parFIELD  &&   ,     
ENDIF
m.f = From(m.i, "UnField")  &&    (, .   )
RELEASE M
DIMENSION M[1]  &&    M    ,        ,  -    
SELECT &e;
       FROM (m.a);
       WHERE &f=m.parUN;
       INTO ARRAY M
m.r = ICASE(_TALLY=0, "...  "+m.a+"."+m.f+"="+VALTOTIP(m.parUN,"C"),;  &&     -    
            _TALLY=1 .AND. VARTYPE(M[1])="C", ALLTRIM(M[1]),;  &&   ,   
            _TALLY=1, M[1],;  &&   ,    
                      "..."+ALLTSTR(_TALLY)+"  "+m.a+"."+m.f+"="+VALTOTIP(m.parUN,"C"))  &&    -    
RETURN m.r


*    (  ),      m.parMODA
*  -   ,   (1=0) -   
#DEFINE Moda         ALLTRIM(ICASE(PCOUNT()>=1 .AND. BITTEST(m.parMODA,0), , ()))

*   -   
#DEFINE ItModaNoParent  (PCOUNT()>=1 .AND. BITTEST(m.parMODA,1))

*   (    Combo,     )
#DEFINE ItModaShort  (PCOUNT()>=1 .AND. BITTEST(m.parMODA,2))


*          
* -    "Opera_pwrd"   ""   
*      
FUNCTION 
PARAMETERS m.parMODA
RETURN IIF(BETWEEN(,1,()),;  &&   ?
                   Moda + " ("+IIF(EMPTY(),"",ALLTRIM()+", ")+;
                                    ()+")",;  &&  ,     
                   "")  &&      ,       


FUNCTION _  &&      ""
PARAMETERS m.parMODA
PRIVATE ALL LIKE ?
m.r = ""
m.r = SRAZDS(m.r, ", ", IIF(EMPTY(),   "", ALLTRIM()))
RETURN Moda + IIF(EMPTY(m.r), "", " ("+ALLTRIM(m.r)+")")


FUNCTION _  &&      ""-
PARAMETERS m.parMODA
PRIVATE ALL LIKE ?
m.r = ""
m.r = SRAZDS(m.r, ", ", IIF(EMPTY(), "", "/ "+ALLTRIM(STR())))
RETURN ALLTRIM() + IIF(EMPTY(m.r), "", " ("+ALLTRIM(m.r)+")")


FUNCTION _  &&      ""-
PARAMETERS m.parMODA
PRIVATE ALL LIKE ?
m.r = ""
m.r = SRAZDS(m.r, ", ", IIF(EMPTY(), "", "/ "+ALLTRIM(STR())))
RETURN ALLTRIM() + IIF(EMPTY(m.r), "", " ("+ALLTRIM(m.r)+")")


FUNCTION _  &&      ""
PARAMETERS m.parMODA
PRIVATE ALL LIKE ?
m.r = ""
m.r = SRAZDS(m.r, ", ", IIF(EMPTY(),  "", Moda))
RETURN ALLTRIM() + IIF(EMPTY(m.r), "",;
                                  IIF(EMPTY(), ALLTRIM(m.r), " ("+ALLTRIM(m.r)+")"))


FUNCTION _  &&      ""
PARAMETERS m.parMODA
PRIVATE ALL LIKE ?
m.r = ""
m.r = SRAZDS(m.r, ", ", IIF(EMPTY(),       "", StringFromTable("", )))
m.r = SRAZDS(m.r, ", ", IIF(EMPTY(),         "", StringFromTable("",     )))
m.r = SRAZDS(m.r, ", ", IIF(EMPTY(),        "", StringFromTable("",    )))
m.r = SRAZDS(m.r, ", ", IIF(EMPTY(), "", ". "+DTOC()))
m.r = ALLTRIM() + IIF(EMPTY(m.r), "", " ("+ALLTRIM(m.r)+")")
RETURN IIF(ItModaShort, LEFT(m.r,100), m.r)


FUNCTION _  &&      "" (.   )
PARAMETERS m.parMODA
PRIVATE ALL LIKE ?
m.r = ""
m.r = SRAZDS(m.r, ", ", DTOC())
m.r = SRAZDS(m.r, ", ", IIF(EMPTY(),   "", CHR(13)+CHR(10)+". " +StringFromTable("", )))
m.r = SRAZDS(m.r, ", ", IIF(EMPTY(),   "", CHR(13)+CHR(10)+" "+StringFromTable("",    )))
RETURN ALLTRIM(m.r)


FUNCTION _  &&      "" (.   )
PARAMETERS m.parMODA
PRIVATE ALL LIKE ?
m.r = ""
m.r = SRAZDS(m.r, ", ", IIF(EMPTY(),   "", StringFromTable("", )))
m.r = SRAZDS(m.r, ", ", IIF(EMPTY(),   "", ALLTSTR()+" ."))
m.r = SRAZDS(m.r, ", ", IIF(EMPTY(), "", ALLTSTR()+" ./."))
m.r = SRAZDS(m.r, ", ", IIF(EMPTY(),  "", "( "+ALLTSTR()+"%)"))
m.r = SRAZDS(m.r, ", ", IIF(EMPTY() .OR. EMPTY(),  "", " "+ALLTSTR(**(100-)/100, 2))+" .")
RETURN ALLTRIM(m.r)


FUNCTION _  &&      "" (.   )
PARAMETERS m.parMODA
PRIVATE ALL LIKE ?
m.r = ""
m.r = SRAZDS(m.r, ", ", DTOC())
m.r = SRAZDS(m.r, ", ", IIF(EMPTY(),   "", CHR(13)+CHR(10)+". "+StringFromTable("", )))
m.r = SRAZDS(m.r, ", ", IIF(EMPTY(),   "", CHR(13)+CHR(10)+". "+StringFromTable("",  )))
RETURN ALLTRIM(m.r)


FUNCTION _  &&      "" (.   )
PARAMETERS m.parMODA
PRIVATE ALL LIKE ?
m.r = ""
m.r = SRAZDS(m.r, ", ", IIF(EMPTY(),   "", ALLTSTR()+" ."))
m.r = SRAZDS(m.r, ", ", ALLTSTR()+'/'+ALLTSTR()+" .")
m.r = SRAZDS(m.r, ", ", IIF(EMPTY(),        "", CHR(13)+CHR(10)+StringFromTable("", )))
RETURN ALLTRIM(m.r) + IIF(EMPTY(), "", IIF(EMPTY(m.r),""," (")+ALLTRIM()+IIF(EMPTY(m.r),"",")"))


#UNDEFINE Moda





**************************************************************************
*    ,    ,    .
* (1) -     ,   ,      
* (2) -   ,    
* [3] -   , ,       
*       (,    ,  "2UnField")
* ..  ( ,   ) :
*     -      
*     -    
*     -        
* !  /    ,     (Relation, )  
*                  ()   
* :             , - ADBOBJECTS(A, "RELATION"),   -  ...
**************************************************************************
FUNCTION From
PARAMETERS m.parI, m.parCOLUMN, m.par2I
PRIVATE ALL LIKE ?
m.p = PCOUNT()

#DEFINE   From

IF m.p=1 .AND. TYPE("m.parI",1)="A"  &&  /:    (@1)
   EXTERNAL ARRAY parI
   * [1] -   
   * [2] -    
   * [3] -      
   * [4] -   ,   ( ) ,     (Candidate)   I
   * [5] - ,                
   * [6] -  ,     ( ,      ,     )
   * [7] -      (.  --),       
   DIMENSION parI[1]
   STORE "" TO parI

   *                Caption                 Alias                  Form        UnField(Candidate) StringEval    2Alias      2UnField
   =aADDMASS(@parI, " ",     "",           "Kateg_t",  "",      "",   "",   "")
   =aADDMASS(@parI, "-", "",              "Strana_p", "",       "",     "",   "")

   m.x = "LEFT(_(), 1000)"
   =aADDMASS(@parI, "-",      "",           "Firma_p",  "",      m.x,          "",  "")

   m.x = "LEFT(_(), 1000)"
   =aADDMASS(@parI, "-",   "",               "Firma_i",  "",        m.x,          "",   "")

   m.x = "LEFT(_(), 1000)"
   =aADDMASS(@parI, "",              "",             "Klienty",  "",      m.x,          "",  "")

   m.x = "LEFT(_(), 1000)"
   =aADDMASS(@parI, "",           "",          "Sotrud",   "",      m.x,          "",  "")
   =aADDMASS(@parI, "",           "",          "Sotrud",   "",      m.x,          "",  "")

   m.x = "LEFT(_(), 1000)"
   =aADDMASS(@parI, "",               "",              "Tovary",   "",       m.x,          "",  "")
   =aADDMASS(@parI, "",               "",              "Tovary",   "",       m.x,          "", "")

   m.x = "LEFT(_(), 1000)"
   =aADDMASS(@parI, "",              "",             "Prodaga",  "",      m.x,          "",  "")

   m.x = "LEFT(_(), 1000)"
   =aADDMASS(@parI, " ",       "",             "Prodano",  "",      m.x,          "", "")

   m.x = "LEFT(_(), 1000)"
   =aADDMASS(@parI, "",              "",             "Zakupka",  "",      m.x,          "", "")

   m.x = "LEFT(_(), 1000)"
   =aADDMASS(@parI, " ",      "",            "Postavka", "",      m.x,          "", "")
   RETURN
ENDIF

EXTERNAL ARRAY   &&        

m.i = 0  &&   1    
IF m.p>=1  &&    ,   ,             
   DO CASE
      CASE VARTYPE(m.parI)="N" .AND. m.parI>0  &&     
           m.i = m.parI
      CASE VARTYPE(m.parI)="C" .AND. !EMPTY(m.parI)
           m.x = ALLTRIM(m.parI)
           m.i = ASCAN(, m.x, 1, -1, 2, 1+2+4+8)  &&  m.x  2   (   ),   
           IF m.i=0
              m.i = ASCAN(, m.x, 1, -1, 1, 1+2+4+8)  &&  m.x  1   (  ),   
           ENDIF
           IF m.i=0
              m.i = ASCAN(, m.x, 1, -1, 3, 1+2+4+8)  &&  m.x  3   (  ),   
           ENDIF
   ENDCASE
ENDIF

m.b = ""  &&   ,      m.b  "2Alias"  ,  m.i="Alias" ( )
IF m.p>=3  &&  -,        Alias ,      2Alias
   DO CASE
      CASE VARTYPE(m.par2I)="N" .AND. m.par2I>0  &&      2
           m.b = (m.par2I, "Alias")
      CASE VARTYPE(m.par2I)="C" .AND. !EMPTY(m.par2I)
           m.b = (m.par2I, "Alias")
   ENDCASE
ENDIF

m.r = .NULL.  &&  
DO CASE
   CASE m.p=0  &&     
        m.r = ALEN(,1)
   OTHERWISE
        IF !EMPTY(m.b) .AND. !EMPTY(m.i)  &&    
           m.a = (m.i, "Alias")  &&  1
           m.i = 0
           FOR m.j=1 TO ALEN(,1)
               IF m.a=[m.j,2] .AND. [m.j,2]=m.a .AND.;
                  m.b=[m.j,6] .AND. [m.j,6]=m.b
                  m.i = m.j
               ENDIF
           ENDFOR
        ENDIF
        IF m.p<2 .OR. EMPTY(m.parCOLUMN)  &&        
           m.r = m.i
           IF m.i=0
              ERROR " : "+VALTOTIP(m.parI, "C")+" "+;
                    IIF(m.p<2, "", VALTOTIP(m.parCOLUMN, "C"))
           ENDIF
        ELSE  &&        
           m.c = ICASE(VARTYPE(m.parCOLUMN)="N", m.parCOLUMN,;  &&     
                       m.parCOLUMN="Caption",    1,;            &&   .,   ,   
                       m.parCOLUMN="Alias",      2,;            &&  () 
                       m.parCOLUMN="Form",       3,;            &&      
                       m.parCOLUMN="UnField",    4,;            &&  , . 
                       m.parCOLUMN="StringEval", 5,;            &&      
                       m.parCOLUMN="2Alias",     6,;            &&  () ,    
                       m.parCOLUMN="2UnField",   7,;            &&      (.  --),       
                                                 0)
           IF m.i>0 .AND. m.c>0
              m.r = [m.i, m.c]
              IF VARTYPE(m.r)="C"
                 m.r = ALLTRIM(m.r)
              ENDIF
           ELSE
              ERROR " : "+VALTOTIP(m.parI, "C")+" "+;
                    IIF(m.p<2, "", VALTOTIP(m.parCOLUMN, "C"))
           ENDIF
        ENDIF
   OTHERWISE
        ERROR " "
ENDCASE
RETURN m.r
#UNDEFINE 




********************************************************
*   BROW (/  )   m.parALIAS=C (  )
* (1) -   
* [2] -  ,    1 
* [3] -     
* [4] -  
********************************************************
FUNCTION BROWALIAS
PARAMETER m.parALIAS, m.parRECNO, m.parTAG, m.parTITLE
PRIVATE ALL LIKE ?
PRIVATE  m.xSelect, m.xRecno, m.xOrder
m.p = PCOUNT()

m.a = ALIAS()
IF m.p>=1 .AND. !EMPTY(m.parALIAS)
   m.a = m.parALIAS
ENDIF

m.xSelect = SELECT()
SELECT (m.a)
m.xRecno = RECNO()
m.xOrder = ORDER()

m.f = .NULL.  &&  , NULL- RECNO
m.k = .NULL.  &&  , NULL-  
m.b = .F.     &&  BROWSE (  EDIT)
DO CASE
   CASE m.p>=3 .AND. !ISNULL(m.parTAG) .AND. !EMPTY(m.parTAG)  &&   
        m.f = m.parTAG
        m.t = m.f
   CASE m.p>=3    &&    -   (2)  RECNO
        m.t = "RECNO()"
   OTHERWISE  &&    -    ,    
        m.f = FIELD(1)
        m.t = m.f
ENDCASE
DO CASE
   CASE m.p>=2 .AND. !ISNULL(m.parRECNO) .AND. !EMPTY(m.parRECNO)  &&    (   RECNO)
        m.k = m.parRECNO
        m.t = m.t + "=" + VALTOTIP(m.k,"C")
   CASE ISNULL(m.f) .AND. m.p>=1 .AND. ISNULL(m.parRECNO)  &&   RECNO(),   RECNO = NULL (  )
        m.t = " "
        m.b = .T.
   CASE ISNULL(m.f)  &&   RECNO(),   RECNO   -  
        m.k = RECNO()
        m.t = m.t + "=" + VALTOTIP(m.k,"C")
   OTHERWISE  &&     -  
        m.k = EVALUATE(m.f)
        m.t = m.t + "=" + VALTOTIP(m.k,"C")
ENDCASE

m.d = SET("DELETE")
SET DELETE OFF
DO CASE
   CASE !ISNULL(m.f) .AND. TAGNO(m.f)>0  &&   
        SET ORDER TO TAG (m.f)
        m.k = "KEY "+VALTOTIP(m.k, IIF(VARTYPE(m.k)="C","S","C"))
        m.b = .T.
   CASE ISNULL(m.f) .AND. ISNULL(m.k)  &&   ,  (2)=NULL (  )
        m.k = ""
   CASE ISNULL(m.f)  &&       - .. (2)- RECNO()
        IF GORECORD(m.k)
           m.k = "NEXT 1"
        ELSE
           m.k = ""
           m.b = .T.
        ENDIF
   OTHERWISE  &&  (  ) ,   
        LOCATE FOR &f=m.k
        IF FOUND()
           m.k = "NEXT 1"
        ELSE
           m.k = ""
           m.b = .T.
        ENDIF
ENDCASE
m.t = IIF(m.p<4 .OR. EMPTY(m.parTITLE), m.t, m.parTITLE)
PUSH KEY CLEAR
IF m.b
   m.s = CreateTalkWindow("",m.a,15,79)  &&   ,      25x80 ..
ELSE
   m.s = CreateTalkWindow("",m.a,24)
ENDIF
CLEAR TYPEAHEAD
KEYBOARD '{CTRL+F10}'
KEYBOARD "{TAB}"
m.b = IIF(m.b, "BROWSE", "EDIT")
m.w = !ISREADONLY()
m.x = IIF(m.w, "", "NOMODIFY")
m.t = ALLTRIM(m.t+IIF(m.w,""," (ReadOnly)"))
&b &k WINDOW (m.s.Name) IN WINDOW (m.s.Name) TITLE (m.t) &x TIMEOUT 60 
POP KEY
SET DELETE &d
IF VARTYPE(m.s)="O"
   m.s.Release
ENDIF
=GORECORD(m.xRecno, m.a)
=SETORDER(m.xOrder)
SELECT (m.xSelect)
RETURN .T.




************************************************************************************************
*    Zaprosy.scx (  , ,  )
*   (1) -   (""  "")
*   (2) -   WHERE  ,    WHERE
*   ,  .T.   
************************************************************************************************
FUNCTION __
LPARAMETERS m.parCommand, m.par, m.parWHERE
PRIVATE ALL LIKE ?
PRIVATE m.xSelect, m., m., m., m., m.

m.xSelect = SELECT()

m.         = m.par  &&  
m.           = From(m., "Alias")    &&  ()  
m. = From(m., "Caption")  &&   
m.         = SYS(2015)  &&   ,            WHERE

m.w = STRTRAN(m.parWHERE, CHR(13)+CHR(10), "")  &&  WHERE,    ( )

IF EMPTY(m.w)
   DO D_D WITH -1,-1,3,"  "
   SELECT (m.xSelect)
   RETURN .F.
ENDIF

SELECT 0
m. = .NULL.  &&    
TRY
    SELECT *;  &&    ,       
           FROM (m.);
           INTO CURSOR (m.) NOFILTER;
           &w
CATCH TO m.
ENDTRY
IF !ISNULL(m.)
   DO D_D WITH -1,-1,3,m..Message
   SELECT (m.xSelect)
   RETURN .F.
ENDIF

IF RECCOUNT()=0  &&  0 
   WAIT "     WHERE" WINDOW NOWAIT
   DO BEEPER WITH 0.1
   SELECT (m.xSelect)
   RETURN .F.
ENDIF

m. = .NULL.  &&        
DO CASE
   CASE m.parCommand="Report"
        PRIVATE m.
        m. = m.w
        m.f = From(m., "Form")  &&          
        DO RPT WITH (m.f)  &&      

   CASE m.parCommand="Browse"
        =BROWALIAS(m., .NULL., .NULL., m.)  &&       

   CASE m.parCommand="Delete"
        IF D_D(-1,-1,1,.F.,"  "+ALLTSTR(RECCOUNT())+"    "+m.)
           TRY
               WAIT "..." WINDOW NOWAIT

               DELETE FROM (m.) &w  && SQL-,    .   

               WAIT " " WINDOW NOWAIT
               DO BEEPER WITH 0.9
           CATCH TO m.
           ENDTRY
        ENDIF

   CASE m.parCommand="Update"
        DO FORM UpdateFields WITH (m.) TO m.z  &&       
        IF VARTYPE(m.z)="C" .AND. !EMPTY(m.z)
           IF D_D(-1,-1,1,.F.,"  "+ALLTSTR(RECCOUNT())+"    "+m.+":"+;
                  CHR(13)+CHR(13)+;
                  STRTRAN(m.z,",",CHR(13)))
              TRY
                  WAIT "..." WINDOW NOWAIT

                  UPDATE (m.) SET &z &w  && SQL-,   .   .   

                  WAIT " " WINDOW NOWAIT
                  DO BEEPER WITH 0.9
              CATCH TO m.
              ENDTRY
           ENDIF
        ENDIF

   CASE m.parCommand="Charts"  &&     
        WAIT " ..." WINDOW NOWAIT

        m.b = IIF(m.="", "", "")  &&  ,  .  
        m.x = From(m.b,  "UnField", m.)  && .       ( )
        m.y = From(m.b, "2UnField", m.)  && .      

        SELECT 0
        m.s = SYS(2015)  &&   
        SELECT CAST(0  AS I)      AS ,;    &&      -    
               CAST("" AS C(150)) AS , *;
               FROM (m.);
               INTO CURSOR (m.s) READWRITE  &&   ,     "",    
        SCAN FOR !EMPTY(&y)  &&          
             REPLACE  WITH StringFromTable(m.b, &y, "")  &&    
             REPLACE   WITH StringFromTable("", )  &&    
        ENDSCAN
        
        SELECT 0
        m.a = SYS(2015)  &&   
        m.x = IIF(m.="", "",    "")       &&   
        m.y = IIF(m.="", "", "")  &&   
        SELECT , ,;  &&      ,    /
               SUM(&x * &y) AS ;
               FROM (m.s);
               INTO CURSOR (m.a);
               GROUP BY ;
               ORDER BY 
        USE IN (m.s)
       
        =_XLS__(m.a, m.+"   ")  &&  XLS-  ,   Excel
        * =BROWALIAS(m.a, .NULL., .NULL., m.)  &&   
            
        USE IN (m.a)

   OTHERWISE
        ERROR " : "+VALTOTIP(m.parCommand, "C")
ENDCASE
IF !EMPTY(m.) .AND. USED(m.)  &&   
   USE IN (m.)
ENDIF
IF !ISNULL(m.)
   DO D_D WITH -1,-1,3,m..Message
ENDIF

SELECT (m.xSelect)




FUNCTION _XLS__
PARAMETERS m.parALIAS, m.par
PRIVATE ALL LIKE ?
PRIVATE m.xSelect, m.oExcel
m.p = PCOUNT()

wait " ..." window nowait

m.xSelect = select()

m.oExcel = RPTxlt("", .F., .NULL.)  &&  Excel    (.F.),    ("")
IF !VARTYPE(m.oExcel)="O"
   SELECT (m.xSelect)
   RETURN .F.
ENDIF

m.c = 0  &&    
m.l = 0  &&      XLS

IF m.p>=2 .AND. !EMPTY(m.par)  &&    XLS-  
   m.l = m.l + 1
   RELEASE Z
   DIMENSION Z[1]
   Z[1] = m.par
   m.f = "FontBold"+CHR(13)+;
         "AutoSize"+CHR(13)+;
         "BorderWidth=2"
   =oCellsLine(m.oExcel, m.l, 1, @Z, m.f)  &&    
   RELEASE Z
ENDIF

*   ,     ,    
m.l = m.l+1  &&  1 -  
m. = m.l

SELECT (m.parALIAS)
SCAN  &&    [, ]
     WAIT LEFT(ALLTRIM(), 250) WINDOW NOWAIT

     m.c = m.c+1  &&     (   /)

     m.l = m.l+1  &&     XLS-
     =oCellsLine(m.oExcel, m.l, 1, ALLTRIM(), )  &&       XLS,    1
ENDSCAN

RELEASE Z
DIMENSION Z[1]
STORE "" TO Z
m.f = "BorderWidth=1"
=oCellsLine(m.oExcel, 0, 0, @Z, m.f)  &&       
RELEASE Z

RELEASE Z
DIMENSION Z[1]
STORE "" TO Z
=aADDMASS(@Z, "")  &&  
=aADDMASS(@Z, "")
m.f = "Alignment=Center"+CHR(13)+;
      "FontBold"+CHR(13)+;
      "AutoSize"+CHR(13)+;
      "BorderWidth=3"+CHR(13)+;
      "AutoFilter"+CHR(13)+;
      "PrintTitleRows"
=oCellsLine(m.oExcel, m., 1, @Z, m.f)  &&    
RELEASE Z

WITH m.oExcel
     m.d = .Cells(m.+1, 1).Address + ":"+;  &&     ,     ("A3:B4")
           .Cells(m.l,2).Address
     .Range(m.d).Select  && "A3:B4"

     .Charts.Add  &&    
    
     WITH .ActiveChart  && 
          .ChartType = 5  && xlPie  
          .SetSourceData(m.oExcel.WorkSheets(1).Range(m.d), 2)
          .Location(2, m.oExcel.WorkSheets(1).Name)
*          .HasTitle = .F.  &&   
     ENDWITH

ENDWITH

*     ( )
WITH m.oExcel
    .Sheets(m.oExcel.WorkSheets(1).Name).Select
    .ActiveSheet.Protect(.T., .T., .T.)  && DrawingObjects:=True, Contents:=True, Scenarios:=True
ENDWITH

DO BEEPER
=RPTxlt(m.oExcel, .T., 0)  &&   XLS-, .T. -    Excel    

select (m.xSelect)
RETURN .T.



**********************************************************************
*       .SCX ( )
* -     DO FORM    
**********************************************************************
PROCEDURE RUNFORM
parameters m.cFormName, m.Par1, m.Par2, m.Par3, m.Par4, m.Par5, m.Par6, m.Par7, m.Par8
LOCAL m.CNT_skjdhskjdhksjhgufd, m.NAM_skjdhskjdhksjhgufd, m.PAR_skjdhskjdhksjhgufd
IF pcount()=0 .or. !vartype(m.cFormName)='C' .OR. EMPTY(m.cFormName)
   ERROR " "
   RETURN
ENDIF
m.PAR_skjdhskjdhksjhgufd = ""
FOR m.CNT_skjdhskjdhksjhgufd=1 TO PCOUNT()-1
    m.NAM_skjdhskjdhksjhgufd = "par"+ALLTRIM(STR(m.CNT_skjdhskjdhksjhgufd))
    m.NAM_skjdhskjdhksjhgufd = IIF(TYPE("m."+m.NAM_skjdhskjdhksjhgufd,1)="A", "@", "m.") + m.NAM_skjdhskjdhksjhgufd
    m.PAR_skjdhskjdhksjhgufd = m.PAR_skjdhskjdhksjhgufd + IIF(EMPTY(m.PAR_skjdhskjdhksjhgufd),"",", ") + m.NAM_skjdhskjdhksjhgufd
ENDFOR
IF EMPTY(m.PAR_skjdhskjdhksjhgufd)
   do form (cFormName)
ELSE
   do form (cFormName) WITH &PAR_skjdhskjdhksjhgufd
ENDIF
RETURN


PROCEDURE RUNFORMto
parameters m.cFormName, m.Par1, m.Par2, m.Par3, m.Par4, m.Par5, m.Par6, m.Par7, m.Par8
LOCAL m.CNT_skjdhskjdhksjhgufd, m.NAM_skjdhskjdhksjhgufd, m.PAR_skjdhskjdhksjhgufd
IF pcount()=0 .or. !vartype(m.cFormName)='C' .OR. EMPTY(m.cFormName)
   ERROR " "
   RETURN .F.
ENDIF
m.PAR_skjdhskjdhksjhgufd = ""
FOR m.CNT_skjdhskjdhksjhgufd=1 TO PCOUNT()-1
    m.NAM_skjdhskjdhksjhgufd = "par"+ALLTRIM(STR(m.CNT_skjdhskjdhksjhgufd))
    m.NAM_skjdhskjdhksjhgufd = IIF(TYPE("m."+m.NAM_skjdhskjdhksjhgufd,1)="A", "@", "m.") + m.NAM_skjdhskjdhksjhgufd
    m.PAR_skjdhskjdhksjhgufd = m.PAR_skjdhskjdhksjhgufd + IIF(EMPTY(m.PAR_skjdhskjdhksjhgufd),"",", ") + m.NAM_skjdhskjdhksjhgufd
ENDFOR
m.CNT_skjdhskjdhksjhgufd = .F.
IF EMPTY(m.PAR_skjdhskjdhksjhgufd)
   do form (cFormName) TO m.CNT_skjdhskjdhksjhgufd
ELSE
   do form (cFormName) WITH &PAR_skjdhskjdhksjhgufd TO m.CNT_skjdhskjdhksjhgufd
ENDIF
RETURN m.CNT_skjdhskjdhksjhgufd




******************************************************************
*   
*     (1)-      
*    (2), [3]      
*     (2) -  ,     / 
*     [3] -   (.  ) (  ReadOnly)
******************************************************************
PROCEDURE Ext_to_ShellExecute
PARAMETERS m.parFILE, m.parTITLE, m.parMODA
PRIVATE ALL LIKE ?
PRIVATE m.xSelect
m.p = PCOUNT()

*   (5) ShellExecute
* SW_HIDE             0
* SW_SHOWNORMAL       1
* SW_NORMAL           1
* SW_SHOWMINIMIZED    2
* SW_SHOWMAXIMIZED    3
* SW_MAXIMIZE         3
* SW_SHOWNOACTIVATE   4
* SW_SHOW             5
* SW_MINIMIZE         6
* SW_SHOWMINNOACTIVE  7
* SW_SHOWNA           8
* SW_RESTORE          9
* SW_SHOWDEFAULT      10
* SW_FORCEMINIMIZE    11
* SW_MAX              11
*  ,    DOC,XLS,       !
*    RPTdot,RPTxlt (  ,    ...)
#DEFINE ShellExecute_5 0

#DEFINE bit  0
#DEFINE bitPack       1
#DEFINE bit866       2
#DEFINE bit1251      3
#DEFINE bitUsedDBF        4  && (1) -    
m.m = IIF(m.p<3, 0, m.parMODA)

m.f = m.parFILE
IF VARTYPE(m.m)="N" .AND. BITTEST(m.m,bitUsedDBF)  &&     
   IF !USED(m.f)
      RETURN ""
   ENDIF
   m.t = IIF(m.p<2 .OR. EMPTY(m.parTITLE), JUSTFNAME(DBF(m.f)), m.parTITLE)

ELSE  &&  , /  (1)
   IF EMPTY(m.f) .OR. !FILE(m.f)
      RETURN ""
   ENDIF

   m.e = JUSTEXT(m.f)
   IF VARTYPE(m.m)="C"
      m.e = m.m
      m.m = 0
   ENDIF
   m.e = ALLTRIM(m.e)

   m.t = IIF(m.p<2 .OR. EMPTY(m.parTITLE), JUSTFNAME(m.f), m.parTITLE)
ENDIF

m.r = ""
m.q = ""
DO CASE
   CASE BITTEST(m.m,bitUsedDBF)  && (1) -    
   CASE BITTEST(m.m,bit866)  .OR.;
        BITTEST(m.m,bit1251) .OR.;
        LIKEin("TXT", m.e)
        m.r = "Text"
   CASE LIKEin("DOC,DOT,DOCX", m.e)
        m.r = "Word"+IIF(m.e="DOT"," Template","")
   CASE LIKEin("XLS,XLT", m.e)
        m.r = "Excel"+IIF(m.e="XLT"," Template","")
   CASE LIKEin("XML,XSL,XSD", m.e)
        m.r = "Xml"
        IF !m.e="XML"
           m.r = m.r+" Template"
        ELSE
           m.q = "XML"
        ENDIF
   CASE LIKEin("EXE,BAT,CMD,COM,DLL,VBS,JS", m.e)
        m.r = "Run"
   CASE LIKEin("ARJ,RAR,ZIP,CAB,PCG,PAC,7Z", m.e)
        m.r = "Pack"
   CASE LIKEin("prg,fxp,spr,spx,sct,scx,vct,vcx,frt,frx,idx,cdx,fpt,dbx,pjt,pjx", m.e)
        m.r = "FoxPro"
   CASE m.e+" "="DBF "
        m.r = "Dbf"
   OTHERWISE
        m.q = "?"
ENDCASE
IF !EMPTY(m.q)  &&     ,    
   m.s = ""
   m.o = .NULL.
   TRY
       m.h = FOPEN(m.f)
       IF m.h>=0
          m.s = FREAD(m.h,200)
          =FCLOSE(m.h)
       ELSE
          DO D_D WITH -1,-1,3,"  "++m.f
       ENDIF
   CATCH TO m.o
       m.h = 0
       DO D_D WITH -1,-1,3,"  "++m.f+++m.o.Message
   ENDTRY
   m.n = OCCURS(CHR(0),m.s)
   DO CASE
      CASE LEN(m.s)=0
      CASE m.q="XML"
           IF OCCURS("/>",m.s)>=1
              m.r = m.r+" Template"
           ENDIF
      CASE LEFT(m.s,2)=="MZ" .AND. m.n>=1
           m.r = "Run"
      CASE LEFT(m.s,4)=="Rar!" .AND. m.n>=1  && RAR
           m.r = "Pack"
      CASE LEFT(m.s,2)==CHR(0x60)+CHR(0xEA) .AND. m.n>=1  && ARJ ?
           m.r = "Pack"
      CASE LEFT(m.s,2)=="PK" .AND. m.n>=1  && ZIP ?
           m.r = "Pack"
      CASE LEN(m.s)>32 .AND. m.n>=2 .AND.;  && DBF ?
           INLIST(ASC(m.s), 0x02, 0x03, 0x30, 0x31, 0x43, 0x63, 0x83, 0x8B, 0xCB, 0xF5, 0xFB)
           m.r = "Dbf"
      OTHERWISE
           m.j = 0
           FOR m.i=1 TO LEN(m.s)
               m.x = SUBSTR(m.s,m.i,1)
               IF !(ISALPHA(m.x) .OR. ASC(m.x)>=ASC(" ")) .AND.;
                  !ISDIGIT(m.x) .AND.;
                  !m.x $ "!@#$%^*:;'()[]{}<>.,?+-=_/|\`~" + '"' + +++++CHR(18)+CHR(15)
                  m.j = m.j+1
                  EXIT
               ENDIF
           ENDFOR
           IF m.j=0
              m.r = "Text"
           ENDIF
   ENDCASE
ENDIF

IF m.p=1
   RETURN m.r
ENDIF

DO CASE
   CASE m.r="Dbf" .OR. BITTEST(m.m,bitUsedDBF)
        m.xSelect = SELECT()
        m.o = .NULL.
        m.y = BITTEST(m.m, bit)
        IF BITTEST(m.m,bitUsedDBF)
           SELECT (m.f)
           m.z = RECCOUNT()
        ELSE
           m.x = IIF(m.y, "", "NOUPDATE")
           SELECT 0
           TRY
               USE (m.f) SHARED &x
               m.z = RECCOUNT()
           CATCH TO m.o
               DO D_D WITH -1,-1,3,m.f++m.o.Message
           ENDTRY
        ENDIF
        IF ISNULL(m.o)
           m.y = (m.y .AND. !ISREADONLY())
           m.d = SET("DELETE")
           SET DELETE OFF
           m.w = CreateTalkWindow("", IIF(m.y,"","")+" DBF", 15, IIF(m.z<=1, 20,79))
           m.x = ""
            
           m.x = IIF(m.y , "", "NOMODIFY")
           m.y = m.t+;
                 IIF(EMPTY(m.z), "", "  ("+ALLTRIM(STR(m.z))+" )")+;
                 IIF(m.y,"", " ReadOnly")
           CLEAR TYPEAHEAD
           KEYBOARD '{CTRL+F10}'
           m.b = IIF(m.z<=1, "CHANGE", "BROWSE")
           &b WINDOW (m.w.Name) IN WINDOW (m.w.Name) TITLE (m.y) &x TIMEOUT 10*60
           IF !BITTEST(m.m,bitUsedDBF)
              USE
           ENDIF
           IF VARTYPE(m.w)="O"
              m.w.Release
           ENDIF
           SET DELETE &d
        ENDIF
        SELECT (m.xSelect)

      CASE INLIST(m.r, "Pack") .AND. BITTEST(m.m, bitPack)
           ShellExecute(0,"open",m.f,"","", ShellExecute_5)
           
      CASE INLIST(m.r, "Run", "Pack")
           m.x = PUTFILEs(" "+JUSTEXT(m.f)+" ", "A:\"+JUSTFNAME(m.f), JUSTEXT(m.f))
           IF !EMPTY(m.x)
              m.o = .NULL.
              TRY
                  COPY FILE (m.f) TO (m.x)
                  IF !FILE(m.x)
                     DO D_D WITH -1,-1,3, "   "++m.x
                  ENDIF
              CATCH TO m.o
                  DO D_D WITH -1,-1,3,m.o.Message
              ENDTRY
           ENDIF

      CASE m.r="Word"
*           ShellExecute(0,"open",m.f,"","", ShellExecute_5)
           IF BITTEST(m.m, bit)
              m.o = RPTdot(m.f, "", .NULL.)  &&  Writable,NoShow
              IF VARTYPE(m.o)="O"
                 =RPTdot(m.o, .T., 0)  && .T. -     ,    Alt-F4 (.Saved:=.T.)
              ENDIF
           ELSE
              =RPTdot(m.f, .T., .NULL.)  &&  ReadOnly, Show...
           ENDIF

      CASE m.r="Excel"
*           ShellExecute(0,"open",m.f,"","", ShellExecute_5)
           IF BITTEST(m.m, bit)
              m.o = RPTxlt(m.f, "", .NULL.)  &&  Writable,NoShow
              IF VARTYPE(m.o)="O"
                 =RPTxlt(m.o, .T., 0)  && .T. -     ,    Alt-F4 (.Saved:=.T.)
              ENDIF
           ELSE
              =RPTxlt(m.f, .T., .NULL.)  &&  ReadOnly, Show...
           ENDIF

      CASE m.r="Text"
           DO runform WITH "printfil", (m.f), (m.t)

      CASE m.r="Print"
           ShellExecute(0,"Print",m.f,"","", ShellExecute_5)

      CASE !EMPTY(m.r)
           ShellExecute(0,"open",m.f,"","", ShellExecute_5)

      OTHERWISE  &&   ,    
           DO runform WITH "printfil", (m.f), (m.t)
ENDCASE

RETURN m.r
