*********************************************************************
*      [    (1)]
*    , ..        ,   "_"
*      (   "_")             
*     (,  ,     )
*********************************************************************
FUNCTION TriggerDelete
LPARAMETERS parALIAS
LOCAL t, s, i, b

m.t = IIF(PCOUNT()<1 .OR. EMPTY(m.parALIAS),;
          ALIAS(),;    &&   ,     (   -   )
          m.parALIAS)  &&   ,   

IF EMPTY(SET("DATABASE"))
   WAIT LEFT("Trigger: No current  for "+m.t, 250) WINDOW TIMEOUT 10
   RETURN .F.
ENDIF

*  ,     "_"
m.s = ", , , , , , , , , "
FOR m.i=1 TO GETWORDCOUNT(m.s,",")
    m.b = ALLTRIM(GETWORDNUM(m.s,m.i,","))  &&  ,      "_"

    *     
    DELETE FROM (m.b) WHERE _=&t..  && SQL- DELETE
ENDFOR
RETURN




*********************************************************************
*      ,   , [    (1)]
*********************************************************************
FUNCTION AutoTriggerDelete
LPARAMETERS parALIAS
LOCAL ARRAY aRelations[1]
LOCAL t, nRelations, i, a, b, ai, bi

m.t = IIF(PCOUNT()<1 .OR. EMPTY(m.parALIAS),;
          ALIAS(),;    &&   ,     (   -   )
          m.parALIAS)  &&   ,   


IF EMPTY(SET("DATABASE"))
   WAIT LEFT("Trigger: No current  for "+m.t, 250) WINDOW TIMEOUT 10
   RETURN .F.
ENDIF

*    (, Relation)   [., ., ., ., _]
*        (.    )
*    ,   Init_()   "SET DATABASE TO"
m.nRelations = ADBOBJECTS(aRelations, "RELATION")
IF m.nRelations=0  &&     
   RETURN
ENDIF

FOR m.i=1 TO m.nRelations
    m.a  = ALLTRIM(aRelations[m.i,2])  &&   () ""
    m.b  = ALLTRIM(aRelations[m.i,1])  &&   (-)  ""
    m.ai = ALLTRIM(aRelations[m.i,4])  &&      () "(.)"
    m.bi = ALLTRIM(aRelations[m.i,3])  &&      (-)  "(.)"
    IF !(m.t=m.a .AND. m.a=m.t)  &&        ,   
       LOOP
    ENDIF

    *     
    DELETE FROM (m.b) WHERE &bi=&a..&ai  && SQL- DELETE, ( ->: =.)
ENDFOR
RETURN




**************************************************************************
*    ,    ,    .
* (1) -     ,   ,      
* (2) -   ,    
* [3] -   , ,       
*       (,    ,  "2UnField")
* ..  ( ,   ) :
*     -      
*     -    
*     -        
* !  /    ,     (Relation, )  
*                  ()   
* :             , - ADBOBJECTS(A, "RELATION"),   -  ...
**************************************************************************
FUNCTION From
PARAMETERS m.parI, m.parCOLUMN, m.par2I
PRIVATE ALL LIKE ?
m.p = PCOUNT()

#DEFINE   From

IF m.p=1 .AND. TYPE("m.parI",1)="A"  &&  /:    (@1)
   EXTERNAL ARRAY parI
   * [1] -   
   * [2] -    
   * [3] -      
   * [4] -   ,   ( ) ,     (Candidate)   I
   * [5] - ,                
   * [6] -  ,     ( ,      ,     )
   * [7] -      (.  --),       
   DIMENSION parI[1]
   STORE "" TO parI

   *                Caption                 Alias                  Form        UnField(Candidate) StringEval    2Alias      2UnField
   =aADDMASS(@parI, " ",     "",           "Kateg_t",  "",      "",   "",   "")
   =aADDMASS(@parI, "-", "",              "Strana_p", "",       "",     "",   "")

   m.x = "LEFT(_(), 1000)"
   =aADDMASS(@parI, "-",      "",           "Firma_p",  "",      m.x,          "",  "")

   m.x = "LEFT(_(), 1000)"
   =aADDMASS(@parI, "-",   "",               "Firma_i",  "",        m.x,          "",   "")

   m.x = "LEFT(_(), 1000)"
   =aADDMASS(@parI, "",              "",             "Klienty",  "",      m.x,          "",  "")

   m.x = "LEFT(_(), 1000)"
   =aADDMASS(@parI, "",           "",          "Sotrud",   "",      m.x,          "",  "")
   =aADDMASS(@parI, "",           "",          "Sotrud",   "",      m.x,          "",  "")

   m.x = "LEFT(_(), 1000)"
   =aADDMASS(@parI, "",               "",              "Tovary",   "",       m.x,          "",  "")
   =aADDMASS(@parI, "",               "",              "Tovary",   "",       m.x,          "", "")

   m.x = "LEFT(_(), 1000)"
   =aADDMASS(@parI, "",              "",             "Prodaga",  "",      m.x,          "",  "")

   m.x = "LEFT(_(), 1000)"
   =aADDMASS(@parI, "",              "",             "Prodano",  "",      m.x,          "", "")

   m.x = "LEFT(_(), 1000)"
   =aADDMASS(@parI, " ",       "",             "Zakupka",  "",      m.x,          "", "")

   m.x = "LEFT(_(), 1000)"
   =aADDMASS(@parI, "",             "",            "Postavka", "",      m.x,          "", "")
   RETURN
ENDIF

EXTERNAL ARRAY   &&        

m.i = 0  &&   1    
IF m.p>=1  &&    ,   ,             
   DO CASE
      CASE VARTYPE(m.parI)="N" .AND. m.parI>0  &&     
           m.i = m.parI
      CASE VARTYPE(m.parI)="C" .AND. !EMPTY(m.parI)
           m.x = ALLTRIM(m.parI)
           m.i = ASCAN(, m.x, 1, -1, 2, 1+2+4+8)  &&  m.x  2   (   ),   
           IF m.i=0
              m.i = ASCAN(, m.x, 1, -1, 1, 1+2+4+8)  &&  m.x  1   (  ),   
           ENDIF
           IF m.i=0
              m.i = ASCAN(, m.x, 1, -1, 3, 1+2+4+8)  &&  m.x  3   (  ),   
           ENDIF
   ENDCASE
ENDIF

m.b = ""  &&   ,      m.b  "2Alias"  ,  m.i="Alias" ( )
IF m.p>=3  &&  -,        Alias ,      2Alias
   DO CASE
      CASE VARTYPE(m.par2I)="N" .AND. m.par2I>0  &&      2
           m.b = (m.par2I, "Alias")
      CASE VARTYPE(m.par2I)="C" .AND. !EMPTY(m.par2I)
           m.b = (m.par2I, "Alias")
   ENDCASE
ENDIF

m.r = .NULL.  &&  
DO CASE
   CASE m.p=0  &&     
        m.r = ALEN(,1)
   OTHERWISE
        IF !EMPTY(m.b) .AND. !EMPTY(m.i)  &&    
           m.a = (m.i, "Alias")  &&  1
           m.i = 0
           FOR m.j=1 TO ALEN(,1)
               IF m.a=[m.j,2] .AND. [m.j,2]=m.a .AND.;
                  m.b=[m.j,6] .AND. [m.j,6]=m.b
                  m.i = m.j
               ENDIF
           ENDFOR
        ENDIF
        IF m.p<2 .OR. EMPTY(m.parCOLUMN)  &&        
           m.r = m.i
           IF m.i=0
              ERROR " : "+VALTOTIP(m.parI, "C")+" "+;
                    IIF(m.p<2, "", VALTOTIP(m.parCOLUMN, "C"))
           ENDIF
        ELSE  &&        
           m.c = ICASE(VARTYPE(m.parCOLUMN)="N", m.parCOLUMN,;  &&     
                       m.parCOLUMN="Caption",    1,;            &&   .,   ,   
                       m.parCOLUMN="Alias",      2,;            &&  () 
                       m.parCOLUMN="Form",       3,;            &&      
                       m.parCOLUMN="UnField",    4,;            &&  , . 
                       m.parCOLUMN="StringEval", 5,;            &&      
                       m.parCOLUMN="2Alias",     6,;            &&  () ,    
                       m.parCOLUMN="2UnField",   7,;            &&      (.  --),       
                                                 0)
           IF m.i>0 .AND. m.c>0
              m.r = [m.i, m.c]
              IF VARTYPE(m.r)="C"
                 m.r = ALLTRIM(m.r)
              ENDIF
           ELSE
              ERROR " : "+VALTOTIP(m.parI, "C")+" "+;
                    IIF(m.p<2, "", VALTOTIP(m.parCOLUMN, "C"))
           ENDIF
        ENDIF
   OTHERWISE
        ERROR " "
ENDCASE
RETURN m.r
#UNDEFINE 




**************************************************************************************
*     (SET)    DataSession=2 (    )
* .      FormWizStd (  - FormWizStd    (  Load))
**************************************************************************************
PROCEDURE Load_

SET TALK OFF       &&     
SET DELETED ON     &&      
SET DATE GERMAN    &&     ..
SET SAFETY OFF     &&       (,   )
SET CENTURY ON     &&   
SET HOURS TO 24    &&    - 24-


SET CONFIRM ON     &&  Enter   
SET ESCAPE OFF     &&   Esc    

SET COLLATE TO "RUSSIAN"  &&   ,   - , (  )
RETURN




************************************************************************************************
*    Zaprosy.scx (  , ,  )
*   (1) -   (""  "")
*   (2) -   WHERE  ,    WHERE
*   ,  .T.   
************************************************************************************************
FUNCTION __
LPARAMETERS m.parCommand, m.par, m.parWHERE
PRIVATE ALL LIKE ?
PRIVATE m.xSelect, m., m., m., m., m.

m.xSelect = SELECT()

m.         = m.par  &&  
m.           = From(m., "Alias")    &&  ()  
m. = From(m., "Caption")  &&   
m.         = SYS(2015)  &&   ,            WHERE

m.w = STRTRAN(m.parWHERE, CHR(13)+CHR(10), "")  &&  WHERE,    ( )

IF EMPTY(m.w)
   DO D_D WITH -1,-1,3,"  "
   SELECT (m.xSelect)
   RETURN .F.
ENDIF

SELECT 0
m. = .NULL.  &&    
TRY
    SELECT *;  &&    ,       
           FROM (m.);
           INTO CURSOR (m.) NOFILTER;
           &w
CATCH TO m.
ENDTRY
IF !ISNULL(m.)
   DO D_D WITH -1,-1,3,m..Message
   SELECT (m.xSelect)
   RETURN .F.
ENDIF

IF RECCOUNT()=0  &&  0 
   WAIT "     WHERE" WINDOW NOWAIT
   DO BEEPER WITH 0.1
   SELECT (m.xSelect)
   RETURN .F.
ENDIF

m. = .NULL.  &&        
DO CASE
   CASE m.parCommand="Report"
        PRIVATE m.
        m. = m.w
        m.f = From(m., "Form")  &&          
        DO RPT WITH (m.f)  &&      

   CASE m.parCommand="Browse"
        =BROWALIAS(m., .NULL., .NULL., m.)  &&       

   CASE m.parCommand="Delete"
        IF D_D(-1,-1,1,.F.,"  "+ALLTSTR(RECCOUNT())+"    "+m.)
           TRY
               WAIT "..." WINDOW NOWAIT

               DELETE FROM (m.) &w  && SQL-,    .   

               WAIT " " WINDOW NOWAIT
               DO BEEPER WITH 0.9
           CATCH TO m.
           ENDTRY
        ENDIF

   CASE m.parCommand="Update"
        DO FORM UpdateFields WITH (m.) TO m.z  &&       
        IF VARTYPE(m.z)="C" .AND. !EMPTY(m.z)
           IF D_D(-1,-1,1,.F.,"  "+ALLTSTR(RECCOUNT())+"    "+m.+":"+;
                  CHR(13)+CHR(13)+;
                  STRTRAN(m.z,",",CHR(13)))
              TRY
                  WAIT "..." WINDOW NOWAIT

                  UPDATE (m.) SET &z &w  && SQL-,   .   .   

                  WAIT " " WINDOW NOWAIT
                  DO BEEPER WITH 0.9
              CATCH TO m.
              ENDTRY
           ENDIF
        ENDIF

   CASE m.parCommand="Charts"  &&     
        WAIT " ..." WINDOW NOWAIT

        m.b = IIF(m.="", "", "")  &&  ,  .  
        m.x = From(m.b,  "UnField", m.)  && .       ( )
        m.y = From(m.b, "2UnField", m.)  && .      

        SELECT 0
        m.s = SYS(2015)  &&   
        SELECT CAST(0  AS I)      AS ,;    &&      -    
               CAST("" AS C(150)) AS , *;
               FROM (m.);
               INTO CURSOR (m.s) READWRITE  &&   ,     "",    
        SCAN FOR !EMPTY(&y)  &&          
             REPLACE  WITH StringFromTable(m.b, &y, "")  &&    
             REPLACE   WITH StringFromTable("", )  &&    
        ENDSCAN
        
        SELECT 0
        m.a = SYS(2015)  &&   
        m.x = IIF(m.="", "",    "")       &&   
        m.y = IIF(m.="", "", "")  &&   
        SELECT , ,;  &&      ,    /
               SUM(&x * &y) AS ;
               FROM (m.s);
               INTO CURSOR (m.a);
               GROUP BY ;
               ORDER BY 
        USE IN (m.s)
       
        =_XLS__(m.a, m.+"   ")  &&  XLS-  ,   Excel
        * =BROWALIAS(m.a, .NULL., .NULL., m.)  &&   
            
        USE IN (m.a)

   OTHERWISE
        ERROR " : "+VALTOTIP(m.parCommand, "C")
ENDCASE
IF !EMPTY(m.) .AND. USED(m.)  &&   
   USE IN (m.)
ENDIF
IF !ISNULL(m.)
   DO D_D WITH -1,-1,3,m..Message
ENDIF

SELECT (m.xSelect)




FUNCTION _XLS__
PARAMETERS m.parALIAS, m.par
PRIVATE ALL LIKE ?
PRIVATE m.xSelect, m.oExcel
m.p = PCOUNT()

wait " ..." window nowait

m.xSelect = select()

m.oExcel = RPTxlt("", .F., .NULL.)  &&  Excel    (.F.),    ("")
IF !VARTYPE(m.oExcel)="O"
   SELECT (m.xSelect)
   RETURN .F.
ENDIF

m.c = 0  &&    
m.l = 0  &&      XLS

IF m.p>=2 .AND. !EMPTY(m.par)  &&    XLS-  
   m.l = m.l + 1
   RELEASE Z
   DIMENSION Z[1]
   Z[1] = m.par
   m.f = "FontBold"+CHR(13)+;
         "AutoSize"+CHR(13)+;
         "BorderWidth=2"
   =oCellsLine(m.oExcel, m.l, 1, @Z, m.f)  &&    
   RELEASE Z
ENDIF

*   ,     ,    
m.l = m.l+1  &&  1 -  
m. = m.l

SELECT (m.parALIAS)
SCAN  &&    [, ]
     WAIT LEFT(ALLTRIM(), 250) WINDOW NOWAIT

     m.c = m.c+1  &&     (   /)

     m.l = m.l+1  &&     XLS-
     =oCellsLine(m.oExcel, m.l, 1, ALLTRIM(), )  &&       XLS,    1
ENDSCAN

RELEASE Z
DIMENSION Z[1]
STORE "" TO Z
m.f = "BorderWidth=1"
=oCellsLine(m.oExcel, 0, 0, @Z, m.f)  &&       
RELEASE Z

RELEASE Z
DIMENSION Z[1]
STORE "" TO Z
=aADDMASS(@Z, "")  &&  
=aADDMASS(@Z, "")
m.f = "Alignment=Center"+CHR(13)+;
      "FontBold"+CHR(13)+;
      "AutoSize"+CHR(13)+;
      "BorderWidth=3"+CHR(13)+;
      "AutoFilter"+CHR(13)+;
      "PrintTitleRows"
=oCellsLine(m.oExcel, m., 1, @Z, m.f)  &&    
RELEASE Z

WITH m.oExcel
     m.d = .Cells(m.+1, 1).Address + ":"+;  &&     ,     ("A3:B4")
           .Cells(m.l,2).Address
     .Range(m.d).Select  && "A3:B4"

     .Charts.Add  &&    
    
     WITH .ActiveChart  && 
          .ChartType = 5  && xlPie  
          .SetSourceData(m.oExcel.WorkSheets(1).Range(m.d), 2)
          .Location(2, m.oExcel.WorkSheets(1).Name)
*          .HasTitle = .F.  &&   
     ENDWITH

ENDWITH

*     ( )
WITH m.oExcel
    .Sheets(m.oExcel.WorkSheets(1).Name).Select
    .ActiveSheet.Protect(.T., .T., .T.)  && DrawingObjects:=True, Contents:=True, Scenarios:=True
ENDWITH

DO BEEPER
=RPTxlt(m.oExcel, .T., 0)  &&   XLS-, .T. -    Excel    

select (m.xSelect)
RETURN .T.



**************************************************************************
*       (1),     (2)
*  () ..       
*   [3] -      (    )
**************************************************************************
FUNCTION StringFromTable
PARAMETERS m.parI, m.parUN, m.parFIELD
PRIVATE ALL LIKE ?
m.p = PCOUNT()
m.i = From(m.parI)        &&  (       , From())
m.a = From(m.i, "Alias")  &&    
IF m.p<3 .OR. EMPTY(m.parFIELD)   &&        
   m.e = From(m.i, "StringEval")  &&       
ELSE
   m.e = m.parFIELD  &&   ,     
ENDIF
m.f = From(m.i, "UnField")  &&    (, .   )
RELEASE M
DIMENSION M[1]  &&       
SELECT &e;
       FROM (m.a);
       WHERE &f=m.parUN;
       INTO ARRAY M
m.r = ICASE(_TALLY=0, "...  "+m.a+"."+m.f+"="+VALTOTIP(m.parUN,"C"),;  &&    
            _TALLY=1 .AND. VARTYPE(M[1])="C", ALLTRIM(M[1]),;  &&   ,   
            _TALLY=1, M[1],;  &&   ,    
                      "..."+ALLTSTR(_TALLY)+"  "+m.a+"."+m.f+"="+VALTOTIP(m.parUN,"C"))  &&    -    
RETURN m.r


